import * as i0 from '@angular/core';
import { Directive, Input, NgModule } from '@angular/core';

class NgxCyberpunkCtaDirective {
    constructor(renderer, hostElement) {
        this.renderer = renderer;
        this.hostElement = hostElement;
        this._type = 'primary';
        this.tag = "R25";
        renderer.addClass(hostElement.nativeElement, 'cybr-btn');
    }
    get ngxCyberpunkCta() {
        return this._type;
    }
    set ngxCyberpunkCta(val) {
        this._type = val;
        if (this._type === 'secondary') {
            this.renderer.addClass(this.hostElement.nativeElement, 'cybr-btn--secondary');
        }
        else {
            this.renderer.removeClass(this.hostElement.nativeElement, 'cybr-btn--secondary');
        }
    }
    ngOnInit() {
        this.setInnerText();
        this.setTag();
    }
    setInnerText() {
        const innerText = this.hostElement.nativeElement.innerText;
        var glitchSpan = document.createElement('span');
        glitchSpan.classList.add('cybr-btn__glitch');
        glitchSpan.ariaHidden = "true";
        glitchSpan.innerText = innerText;
        this.hostElement.nativeElement.appendChild(glitchSpan);
    }
    // <span aria-hidden class="cybr-btn__tag">R25</span>
    setTag() {
        var _a;
        var glitchSpan = document.createElement('span');
        glitchSpan.classList.add('cybr-btn__tag');
        glitchSpan.ariaHidden = "true";
        glitchSpan.innerText = (_a = this.tag) !== null && _a !== void 0 ? _a : "R25";
        this.hostElement.nativeElement.appendChild(glitchSpan);
    }
}
NgxCyberpunkCtaDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaDirective, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NgxCyberpunkCtaDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.6", type: NgxCyberpunkCtaDirective, selector: "[ngxCyberpunkCta]", inputs: { ngxCyberpunkCta: "ngxCyberpunkCta", tag: "tag" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxCyberpunkCta]'
                }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }]; }, propDecorators: { ngxCyberpunkCta: [{
                type: Input
            }], tag: [{
                type: Input
            }] } });

class NgxCyberpunkCtaModule {
}
NgxCyberpunkCtaModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxCyberpunkCtaModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaModule, declarations: [NgxCyberpunkCtaDirective], exports: [NgxCyberpunkCtaDirective] });
NgxCyberpunkCtaModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: NgxCyberpunkCtaModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxCyberpunkCtaDirective
                    ],
                    imports: [],
                    exports: [
                        NgxCyberpunkCtaDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-cyberpunk-cta
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxCyberpunkCtaDirective, NgxCyberpunkCtaModule };
//# sourceMappingURL=ngx-cyberpunk-cta.mjs.map
